// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: service.proto

package ec.edu.uees.msfacturasrelacional.communication.grpc.generated;

/**
 * Protobuf type {@code Factura}
 */
public final class Factura extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:Factura)
    FacturaOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Factura.newBuilder() to construct.
  private Factura(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Factura() {
    ciudad_ = "";
    empleado_ = "";
    cliente_ = "";
    codigo_ = "";
    fecha_ = "";
    items_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new Factura();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Factura(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            ciudad_ = s;
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            empleado_ = s;
            break;
          }
          case 26: {
            java.lang.String s = input.readStringRequireUtf8();

            cliente_ = s;
            break;
          }
          case 34: {
            java.lang.String s = input.readStringRequireUtf8();

            codigo_ = s;
            break;
          }
          case 42: {
            java.lang.String s = input.readStringRequireUtf8();

            fecha_ = s;
            break;
          }
          case 49: {

            valorTotal_ = input.readDouble();
            break;
          }
          case 57: {

            valorSubTotal_ = input.readDouble();
            break;
          }
          case 65: {

            valorIva_ = input.readDouble();
            break;
          }
          case 74: {
            if (!((mutable_bitField0_ & 0x00000001) != 0)) {
              items_ = new java.util.ArrayList<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item>();
              mutable_bitField0_ |= 0x00000001;
            }
            items_.add(
                input.readMessage(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.parser(), extensionRegistry));
            break;
          }
          default: {
            if (!parseUnknownField(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) != 0)) {
        items_ = java.util.Collections.unmodifiableList(items_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Factura_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Factura_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.class, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.Builder.class);
  }

  public static final int CIUDAD_FIELD_NUMBER = 1;
  private volatile java.lang.Object ciudad_;
  /**
   * <code>string ciudad = 1;</code>
   * @return The ciudad.
   */
  @java.lang.Override
  public java.lang.String getCiudad() {
    java.lang.Object ref = ciudad_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      ciudad_ = s;
      return s;
    }
  }
  /**
   * <code>string ciudad = 1;</code>
   * @return The bytes for ciudad.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getCiudadBytes() {
    java.lang.Object ref = ciudad_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      ciudad_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int EMPLEADO_FIELD_NUMBER = 2;
  private volatile java.lang.Object empleado_;
  /**
   * <code>string empleado = 2;</code>
   * @return The empleado.
   */
  @java.lang.Override
  public java.lang.String getEmpleado() {
    java.lang.Object ref = empleado_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      empleado_ = s;
      return s;
    }
  }
  /**
   * <code>string empleado = 2;</code>
   * @return The bytes for empleado.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getEmpleadoBytes() {
    java.lang.Object ref = empleado_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      empleado_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CLIENTE_FIELD_NUMBER = 3;
  private volatile java.lang.Object cliente_;
  /**
   * <code>string cliente = 3;</code>
   * @return The cliente.
   */
  @java.lang.Override
  public java.lang.String getCliente() {
    java.lang.Object ref = cliente_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      cliente_ = s;
      return s;
    }
  }
  /**
   * <code>string cliente = 3;</code>
   * @return The bytes for cliente.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getClienteBytes() {
    java.lang.Object ref = cliente_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      cliente_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CODIGO_FIELD_NUMBER = 4;
  private volatile java.lang.Object codigo_;
  /**
   * <code>string codigo = 4;</code>
   * @return The codigo.
   */
  @java.lang.Override
  public java.lang.String getCodigo() {
    java.lang.Object ref = codigo_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      codigo_ = s;
      return s;
    }
  }
  /**
   * <code>string codigo = 4;</code>
   * @return The bytes for codigo.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getCodigoBytes() {
    java.lang.Object ref = codigo_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      codigo_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int FECHA_FIELD_NUMBER = 5;
  private volatile java.lang.Object fecha_;
  /**
   * <code>string fecha = 5;</code>
   * @return The fecha.
   */
  @java.lang.Override
  public java.lang.String getFecha() {
    java.lang.Object ref = fecha_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      fecha_ = s;
      return s;
    }
  }
  /**
   * <code>string fecha = 5;</code>
   * @return The bytes for fecha.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getFechaBytes() {
    java.lang.Object ref = fecha_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      fecha_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int VALORTOTAL_FIELD_NUMBER = 6;
  private double valorTotal_;
  /**
   * <code>double valorTotal = 6;</code>
   * @return The valorTotal.
   */
  @java.lang.Override
  public double getValorTotal() {
    return valorTotal_;
  }

  public static final int VALORSUBTOTAL_FIELD_NUMBER = 7;
  private double valorSubTotal_;
  /**
   * <code>double valorSubTotal = 7;</code>
   * @return The valorSubTotal.
   */
  @java.lang.Override
  public double getValorSubTotal() {
    return valorSubTotal_;
  }

  public static final int VALORIVA_FIELD_NUMBER = 8;
  private double valorIva_;
  /**
   * <code>double valorIva = 8;</code>
   * @return The valorIva.
   */
  @java.lang.Override
  public double getValorIva() {
    return valorIva_;
  }

  public static final int ITEMS_FIELD_NUMBER = 9;
  private java.util.List<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item> items_;
  /**
   * <code>repeated .Item items = 9;</code>
   */
  @java.lang.Override
  public java.util.List<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item> getItemsList() {
    return items_;
  }
  /**
   * <code>repeated .Item items = 9;</code>
   */
  @java.lang.Override
  public java.util.List<? extends ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder> 
      getItemsOrBuilderList() {
    return items_;
  }
  /**
   * <code>repeated .Item items = 9;</code>
   */
  @java.lang.Override
  public int getItemsCount() {
    return items_.size();
  }
  /**
   * <code>repeated .Item items = 9;</code>
   */
  @java.lang.Override
  public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item getItems(int index) {
    return items_.get(index);
  }
  /**
   * <code>repeated .Item items = 9;</code>
   */
  @java.lang.Override
  public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder getItemsOrBuilder(
      int index) {
    return items_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getCiudadBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, ciudad_);
    }
    if (!getEmpleadoBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, empleado_);
    }
    if (!getClienteBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 3, cliente_);
    }
    if (!getCodigoBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 4, codigo_);
    }
    if (!getFechaBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 5, fecha_);
    }
    if (valorTotal_ != 0D) {
      output.writeDouble(6, valorTotal_);
    }
    if (valorSubTotal_ != 0D) {
      output.writeDouble(7, valorSubTotal_);
    }
    if (valorIva_ != 0D) {
      output.writeDouble(8, valorIva_);
    }
    for (int i = 0; i < items_.size(); i++) {
      output.writeMessage(9, items_.get(i));
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getCiudadBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, ciudad_);
    }
    if (!getEmpleadoBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, empleado_);
    }
    if (!getClienteBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, cliente_);
    }
    if (!getCodigoBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, codigo_);
    }
    if (!getFechaBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(5, fecha_);
    }
    if (valorTotal_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(6, valorTotal_);
    }
    if (valorSubTotal_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(7, valorSubTotal_);
    }
    if (valorIva_ != 0D) {
      size += com.google.protobuf.CodedOutputStream
        .computeDoubleSize(8, valorIva_);
    }
    for (int i = 0; i < items_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, items_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura)) {
      return super.equals(obj);
    }
    ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura other = (ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura) obj;

    if (!getCiudad()
        .equals(other.getCiudad())) return false;
    if (!getEmpleado()
        .equals(other.getEmpleado())) return false;
    if (!getCliente()
        .equals(other.getCliente())) return false;
    if (!getCodigo()
        .equals(other.getCodigo())) return false;
    if (!getFecha()
        .equals(other.getFecha())) return false;
    if (java.lang.Double.doubleToLongBits(getValorTotal())
        != java.lang.Double.doubleToLongBits(
            other.getValorTotal())) return false;
    if (java.lang.Double.doubleToLongBits(getValorSubTotal())
        != java.lang.Double.doubleToLongBits(
            other.getValorSubTotal())) return false;
    if (java.lang.Double.doubleToLongBits(getValorIva())
        != java.lang.Double.doubleToLongBits(
            other.getValorIva())) return false;
    if (!getItemsList()
        .equals(other.getItemsList())) return false;
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + CIUDAD_FIELD_NUMBER;
    hash = (53 * hash) + getCiudad().hashCode();
    hash = (37 * hash) + EMPLEADO_FIELD_NUMBER;
    hash = (53 * hash) + getEmpleado().hashCode();
    hash = (37 * hash) + CLIENTE_FIELD_NUMBER;
    hash = (53 * hash) + getCliente().hashCode();
    hash = (37 * hash) + CODIGO_FIELD_NUMBER;
    hash = (53 * hash) + getCodigo().hashCode();
    hash = (37 * hash) + FECHA_FIELD_NUMBER;
    hash = (53 * hash) + getFecha().hashCode();
    hash = (37 * hash) + VALORTOTAL_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getValorTotal()));
    hash = (37 * hash) + VALORSUBTOTAL_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getValorSubTotal()));
    hash = (37 * hash) + VALORIVA_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        java.lang.Double.doubleToLongBits(getValorIva()));
    if (getItemsCount() > 0) {
      hash = (37 * hash) + ITEMS_FIELD_NUMBER;
      hash = (53 * hash) + getItemsList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code Factura}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:Factura)
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.FacturaOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Factura_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Factura_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.class, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.Builder.class);
    }

    // Construct using ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getItemsFieldBuilder();
      }
    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      ciudad_ = "";

      empleado_ = "";

      cliente_ = "";

      codigo_ = "";

      fecha_ = "";

      valorTotal_ = 0D;

      valorSubTotal_ = 0D;

      valorIva_ = 0D;

      if (itemsBuilder_ == null) {
        items_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        itemsBuilder_.clear();
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Service.internal_static_Factura_descriptor;
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura getDefaultInstanceForType() {
      return ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.getDefaultInstance();
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura build() {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura buildPartial() {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura result = new ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura(this);
      int from_bitField0_ = bitField0_;
      result.ciudad_ = ciudad_;
      result.empleado_ = empleado_;
      result.cliente_ = cliente_;
      result.codigo_ = codigo_;
      result.fecha_ = fecha_;
      result.valorTotal_ = valorTotal_;
      result.valorSubTotal_ = valorSubTotal_;
      result.valorIva_ = valorIva_;
      if (itemsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          items_ = java.util.Collections.unmodifiableList(items_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.items_ = items_;
      } else {
        result.items_ = itemsBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }
    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.setField(field, value);
    }
    @java.lang.Override
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }
    @java.lang.Override
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }
    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }
    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }
    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura) {
        return mergeFrom((ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura other) {
      if (other == ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura.getDefaultInstance()) return this;
      if (!other.getCiudad().isEmpty()) {
        ciudad_ = other.ciudad_;
        onChanged();
      }
      if (!other.getEmpleado().isEmpty()) {
        empleado_ = other.empleado_;
        onChanged();
      }
      if (!other.getCliente().isEmpty()) {
        cliente_ = other.cliente_;
        onChanged();
      }
      if (!other.getCodigo().isEmpty()) {
        codigo_ = other.codigo_;
        onChanged();
      }
      if (!other.getFecha().isEmpty()) {
        fecha_ = other.fecha_;
        onChanged();
      }
      if (other.getValorTotal() != 0D) {
        setValorTotal(other.getValorTotal());
      }
      if (other.getValorSubTotal() != 0D) {
        setValorSubTotal(other.getValorSubTotal());
      }
      if (other.getValorIva() != 0D) {
        setValorIva(other.getValorIva());
      }
      if (itemsBuilder_ == null) {
        if (!other.items_.isEmpty()) {
          if (items_.isEmpty()) {
            items_ = other.items_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureItemsIsMutable();
            items_.addAll(other.items_);
          }
          onChanged();
        }
      } else {
        if (!other.items_.isEmpty()) {
          if (itemsBuilder_.isEmpty()) {
            itemsBuilder_.dispose();
            itemsBuilder_ = null;
            items_ = other.items_;
            bitField0_ = (bitField0_ & ~0x00000001);
            itemsBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getItemsFieldBuilder() : null;
          } else {
            itemsBuilder_.addAllMessages(other.items_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object ciudad_ = "";
    /**
     * <code>string ciudad = 1;</code>
     * @return The ciudad.
     */
    public java.lang.String getCiudad() {
      java.lang.Object ref = ciudad_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        ciudad_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string ciudad = 1;</code>
     * @return The bytes for ciudad.
     */
    public com.google.protobuf.ByteString
        getCiudadBytes() {
      java.lang.Object ref = ciudad_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        ciudad_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string ciudad = 1;</code>
     * @param value The ciudad to set.
     * @return This builder for chaining.
     */
    public Builder setCiudad(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      ciudad_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string ciudad = 1;</code>
     * @return This builder for chaining.
     */
    public Builder clearCiudad() {
      
      ciudad_ = getDefaultInstance().getCiudad();
      onChanged();
      return this;
    }
    /**
     * <code>string ciudad = 1;</code>
     * @param value The bytes for ciudad to set.
     * @return This builder for chaining.
     */
    public Builder setCiudadBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      ciudad_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object empleado_ = "";
    /**
     * <code>string empleado = 2;</code>
     * @return The empleado.
     */
    public java.lang.String getEmpleado() {
      java.lang.Object ref = empleado_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        empleado_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string empleado = 2;</code>
     * @return The bytes for empleado.
     */
    public com.google.protobuf.ByteString
        getEmpleadoBytes() {
      java.lang.Object ref = empleado_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        empleado_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string empleado = 2;</code>
     * @param value The empleado to set.
     * @return This builder for chaining.
     */
    public Builder setEmpleado(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      empleado_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string empleado = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearEmpleado() {
      
      empleado_ = getDefaultInstance().getEmpleado();
      onChanged();
      return this;
    }
    /**
     * <code>string empleado = 2;</code>
     * @param value The bytes for empleado to set.
     * @return This builder for chaining.
     */
    public Builder setEmpleadoBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      empleado_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object cliente_ = "";
    /**
     * <code>string cliente = 3;</code>
     * @return The cliente.
     */
    public java.lang.String getCliente() {
      java.lang.Object ref = cliente_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        cliente_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string cliente = 3;</code>
     * @return The bytes for cliente.
     */
    public com.google.protobuf.ByteString
        getClienteBytes() {
      java.lang.Object ref = cliente_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        cliente_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string cliente = 3;</code>
     * @param value The cliente to set.
     * @return This builder for chaining.
     */
    public Builder setCliente(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      cliente_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string cliente = 3;</code>
     * @return This builder for chaining.
     */
    public Builder clearCliente() {
      
      cliente_ = getDefaultInstance().getCliente();
      onChanged();
      return this;
    }
    /**
     * <code>string cliente = 3;</code>
     * @param value The bytes for cliente to set.
     * @return This builder for chaining.
     */
    public Builder setClienteBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      cliente_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object codigo_ = "";
    /**
     * <code>string codigo = 4;</code>
     * @return The codigo.
     */
    public java.lang.String getCodigo() {
      java.lang.Object ref = codigo_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        codigo_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string codigo = 4;</code>
     * @return The bytes for codigo.
     */
    public com.google.protobuf.ByteString
        getCodigoBytes() {
      java.lang.Object ref = codigo_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        codigo_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string codigo = 4;</code>
     * @param value The codigo to set.
     * @return This builder for chaining.
     */
    public Builder setCodigo(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      codigo_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string codigo = 4;</code>
     * @return This builder for chaining.
     */
    public Builder clearCodigo() {
      
      codigo_ = getDefaultInstance().getCodigo();
      onChanged();
      return this;
    }
    /**
     * <code>string codigo = 4;</code>
     * @param value The bytes for codigo to set.
     * @return This builder for chaining.
     */
    public Builder setCodigoBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      codigo_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object fecha_ = "";
    /**
     * <code>string fecha = 5;</code>
     * @return The fecha.
     */
    public java.lang.String getFecha() {
      java.lang.Object ref = fecha_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        fecha_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string fecha = 5;</code>
     * @return The bytes for fecha.
     */
    public com.google.protobuf.ByteString
        getFechaBytes() {
      java.lang.Object ref = fecha_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        fecha_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string fecha = 5;</code>
     * @param value The fecha to set.
     * @return This builder for chaining.
     */
    public Builder setFecha(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      fecha_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string fecha = 5;</code>
     * @return This builder for chaining.
     */
    public Builder clearFecha() {
      
      fecha_ = getDefaultInstance().getFecha();
      onChanged();
      return this;
    }
    /**
     * <code>string fecha = 5;</code>
     * @param value The bytes for fecha to set.
     * @return This builder for chaining.
     */
    public Builder setFechaBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      fecha_ = value;
      onChanged();
      return this;
    }

    private double valorTotal_ ;
    /**
     * <code>double valorTotal = 6;</code>
     * @return The valorTotal.
     */
    @java.lang.Override
    public double getValorTotal() {
      return valorTotal_;
    }
    /**
     * <code>double valorTotal = 6;</code>
     * @param value The valorTotal to set.
     * @return This builder for chaining.
     */
    public Builder setValorTotal(double value) {
      
      valorTotal_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double valorTotal = 6;</code>
     * @return This builder for chaining.
     */
    public Builder clearValorTotal() {
      
      valorTotal_ = 0D;
      onChanged();
      return this;
    }

    private double valorSubTotal_ ;
    /**
     * <code>double valorSubTotal = 7;</code>
     * @return The valorSubTotal.
     */
    @java.lang.Override
    public double getValorSubTotal() {
      return valorSubTotal_;
    }
    /**
     * <code>double valorSubTotal = 7;</code>
     * @param value The valorSubTotal to set.
     * @return This builder for chaining.
     */
    public Builder setValorSubTotal(double value) {
      
      valorSubTotal_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double valorSubTotal = 7;</code>
     * @return This builder for chaining.
     */
    public Builder clearValorSubTotal() {
      
      valorSubTotal_ = 0D;
      onChanged();
      return this;
    }

    private double valorIva_ ;
    /**
     * <code>double valorIva = 8;</code>
     * @return The valorIva.
     */
    @java.lang.Override
    public double getValorIva() {
      return valorIva_;
    }
    /**
     * <code>double valorIva = 8;</code>
     * @param value The valorIva to set.
     * @return This builder for chaining.
     */
    public Builder setValorIva(double value) {
      
      valorIva_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>double valorIva = 8;</code>
     * @return This builder for chaining.
     */
    public Builder clearValorIva() {
      
      valorIva_ = 0D;
      onChanged();
      return this;
    }

    private java.util.List<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item> items_ =
      java.util.Collections.emptyList();
    private void ensureItemsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        items_ = new java.util.ArrayList<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item>(items_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder> itemsBuilder_;

    /**
     * <code>repeated .Item items = 9;</code>
     */
    public java.util.List<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item> getItemsList() {
      if (itemsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(items_);
      } else {
        return itemsBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public int getItemsCount() {
      if (itemsBuilder_ == null) {
        return items_.size();
      } else {
        return itemsBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item getItems(int index) {
      if (itemsBuilder_ == null) {
        return items_.get(index);
      } else {
        return itemsBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder setItems(
        int index, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item value) {
      if (itemsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureItemsIsMutable();
        items_.set(index, value);
        onChanged();
      } else {
        itemsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder setItems(
        int index, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder builderForValue) {
      if (itemsBuilder_ == null) {
        ensureItemsIsMutable();
        items_.set(index, builderForValue.build());
        onChanged();
      } else {
        itemsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder addItems(ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item value) {
      if (itemsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureItemsIsMutable();
        items_.add(value);
        onChanged();
      } else {
        itemsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder addItems(
        int index, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item value) {
      if (itemsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureItemsIsMutable();
        items_.add(index, value);
        onChanged();
      } else {
        itemsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder addItems(
        ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder builderForValue) {
      if (itemsBuilder_ == null) {
        ensureItemsIsMutable();
        items_.add(builderForValue.build());
        onChanged();
      } else {
        itemsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder addItems(
        int index, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder builderForValue) {
      if (itemsBuilder_ == null) {
        ensureItemsIsMutable();
        items_.add(index, builderForValue.build());
        onChanged();
      } else {
        itemsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder addAllItems(
        java.lang.Iterable<? extends ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item> values) {
      if (itemsBuilder_ == null) {
        ensureItemsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, items_);
        onChanged();
      } else {
        itemsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder clearItems() {
      if (itemsBuilder_ == null) {
        items_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        itemsBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public Builder removeItems(int index) {
      if (itemsBuilder_ == null) {
        ensureItemsIsMutable();
        items_.remove(index);
        onChanged();
      } else {
        itemsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder getItemsBuilder(
        int index) {
      return getItemsFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder getItemsOrBuilder(
        int index) {
      if (itemsBuilder_ == null) {
        return items_.get(index);  } else {
        return itemsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public java.util.List<? extends ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder> 
         getItemsOrBuilderList() {
      if (itemsBuilder_ != null) {
        return itemsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(items_);
      }
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder addItemsBuilder() {
      return getItemsFieldBuilder().addBuilder(
          ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.getDefaultInstance());
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder addItemsBuilder(
        int index) {
      return getItemsFieldBuilder().addBuilder(
          index, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.getDefaultInstance());
    }
    /**
     * <code>repeated .Item items = 9;</code>
     */
    public java.util.List<ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder> 
         getItemsBuilderList() {
      return getItemsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder> 
        getItemsFieldBuilder() {
      if (itemsBuilder_ == null) {
        itemsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Item.Builder, ec.edu.uees.msfacturasrelacional.communication.grpc.generated.ItemOrBuilder>(
                items_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        items_ = null;
      }
      return itemsBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:Factura)
  }

  // @@protoc_insertion_point(class_scope:Factura)
  private static final ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura();
  }

  public static ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Factura>
      PARSER = new com.google.protobuf.AbstractParser<Factura>() {
    @java.lang.Override
    public Factura parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new Factura(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Factura> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Factura> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public ec.edu.uees.msfacturasrelacional.communication.grpc.generated.Factura getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

